#ifndef _MYVECTOR_H
#define _MYVECTOR_H

#include <iostream>
using namespace std;

typedef float Point[3];
typedef float vec4[4];
typedef float mat4[4][4];
typedef float mat3[3][3];

class myVector {

public:
  myVector();
  myVector(Point, Point);
  ~myVector();
  
  /* mutators */
  void setBase(const Point);
  void setEnd (const Point);
  void setLength(float ilength);

  /* accessors */
  const Point& getBase() const;
  const Point& getEnd () const;
  float getLength() const;

  void updateLength();

  /* friend declarations */
  friend ostream & operator << (ostream & output, const myVector & v);
private :
    Point base,end;
    float length;
};

#endif
